Page MenuHomePhabricator

API problem in Echo may be showing empty notifications panel
Closed, ResolvedPublic

Description

The designs didn't include this edge case. Currently we show a blank panel:

Event Timeline

Esanders raised the priority of this task from to Needs Triage.
Esanders updated the task description. (Show Details)
Esanders added a project: Notifications.
Esanders added subscribers: Esanders, Pginer-WMF.
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
TheDJ added a subscriber: TheDJ.EditedSep 11 2015, 11:30 AM

Examples of how Bitbucket or phabricator do an empty list message:



See all the tabs on the left of this Empty Bitbucket repo

Pginer-WMF added a comment.EditedSep 11 2015, 12:38 PM

We need to define the empty states. I'll explore some options.

Regarding the immediate impact, it is not clear to me:

  • The message badge is supposed to be shown only after receiving the first message. So the empty state should never be visible.
  • For the alerts badge (which is visible from the beginning) a welcome notification is sent after the user created the account. So the empty state could only be reached on those wikis where that is not happening (i.e., lacking that extension if it is not part of core).

I may be also missing something in the above analysis. In any case, it makes sense to define a clear empty state.
As @TheDJ mentioned, it is a good opportunity to communicate the product tone or even anticipate possible next steps (encourage contributing?). For those interested in more examples, here is a good collection.

  • For the alerts badge (which is visible from the beginning) a welcome notification is sent after the user created the account. So the empty state could only be reached on those wikis where that is not happening (i.e., lacking that extension if it is not part of core).

Their account may have existed before Echo was deployed and not managed to get any alerts until then. (Or the just turned on Echo on their development wiki ;-))

From my observations:

  • no reliable steps to reproduce
  • it happens more frequently than it could be attributed to

Their account may have existed before Echo was deployed and not managed to get any alerts until then. (Or the just turned on Echo on their development wiki ;-))

  • it happens with equal probability to users who enabled "Flow on user talk" and to new users
  • I agree with:

The message badge is supposed to be shown only after receiving the first message. So the empty state should never be visible.

It seems that this issue may be a specific manifestation of T112826. I linked the issue to it to check after the fix.

More screenshots:

Echo popups, in theory should never be empty. There is always at least 1 alert in the alerts popup ("Welcome...") and when the messages popup is empty, it should be invisible.

  • For the alerts badge (which is visible from the beginning) a welcome notification is sent after the user created the account. So the empty state could only be reached on those wikis where that is not happening (i.e., lacking that extension if it is not part of core).

Their account may have existed before Echo was deployed and not managed to get any alerts until then. (Or the just turned on Echo on their development wiki ;-))

Can we add a "welcome" or some such as a first alert if one doesn't exist?

There's another case where alerts/messages popup will be empty: An API error, but that is being fixed right now, and seems to not be this specific bug ?

Change 238903 had a related patch set uploaded (by Mooeypoo):
[wip] Handle API fetching errors

https://gerrit.wikimedia.org/r/238903

DannyH renamed this task from Echo popups look odd when empty to API problem in Echo may be showing empty notifications panel.Sep 17 2015, 4:57 PM
DannyH triaged this task as Normal priority.
DannyH set Security to None.
Catrope assigned this task to Mooeypoo.Sep 17 2015, 5:38 PM

Echo popups, in theory should never be empty. There is always at least 1 alert in the alerts popup ("Welcome...") and when the messages popup is empty, it should be invisible.

That is only shown on the home-wiki. If I make an account at Frwp, and then visit Dewp, I won't get a welcome message at Dewp.

We need to come up with a product solution for this, then. If there are no messages, the message icon is not showing. What do we want to do if there are no alerts? Do we want to hide it, or do we want to inject a "placeholder" message, something like "There are no new alerts yet, explore the wiki to gain experience points!" (only a different phrasing) or do we want to inject an actual "welcome" message to all users that have Echo but don't have any messages at all?

For now, a placeholder message would probably be best. (Otherwise editors will get in the habit of ignoring the "red 1" at less-visited wikis)

Something short and easy to translate. "There are no new alerts yet" works.

Change 239285 had a related patch set uploaded (by Mooeypoo):
Show a default message if no notifications are available

https://gerrit.wikimedia.org/r/239285

Change 238903 merged by jenkins-bot:
Handle API fetching errors

https://gerrit.wikimedia.org/r/238903

Change 239285 merged by jenkins-bot:
Show a default message if no notifications are available

https://gerrit.wikimedia.org/r/239285

A placeholder message encouraging participation would be a good option:


Ideally, the "start contributing" should link to a place where the user is presented ways to contribute. It could work just as a plain text encouragement (although actionable items are always more effective).

Alternatively, we can use the opportunity to describe the purpose of the panel:

If we need an empty state for messages we can make something along the same lines:

Those are awesome!
I split this into a new task specifically for picking and designing the empty options better, rather than concentrating on the technical API error that's in this bug: T113070: Display a 'no notifications' empty option if there are no notifications in the Echo popup

In betalabs - testwiki:

DannyH closed this task as Resolved.Sep 22 2015, 6:32 PM
DannyH added a subscriber: DannyH.